<?php 
/**
 * User_profile_reposition Page Controller
 * @category  Controller
 */
class User_profile_repositionController extends SecureController{
	function __construct(){
		parent::__construct();
		$this->tablename = "user_profile_reposition";
	}
	/**
     * List page records
     * @param $fieldname (filter record by a field) 
     * @param $fieldvalue (filter field value)
     * @return BaseView
     */
	function index($fieldname = null , $fieldvalue = null){
		$request = $this->request;
		$db = $this->GetModel();
		$tablename = $this->tablename;
		$fields = array("user_profile_reposition.id", 
			"employee_details.employee_name AS employee_details_employee_name", 
			"user_profile_reposition.status", 
			"user_profile_reposition.effective_month", 
			"user_profile_reposition.effective_year", 
			"user_profile_reposition.old_portfolio", 
			"portfolio.name AS portfolio_name", 
			"user_profile_reposition.timestamp");
		$pagination = $this->get_pagination(MAX_RECORD_COUNT); // get current pagination e.g array(page_number, page_limit)
		//search table record
		if(!empty($request->search)){
			$text = trim($request->search); 
			$search_condition = "(
				user_profile_reposition.id LIKE ? OR 
				user_profile_reposition.empid LIKE ? OR 
				employee_details.employee_name LIKE ? OR 
				user_profile_reposition.status LIKE ? OR 
				user_profile_reposition.effective_month LIKE ? OR 
				user_profile_reposition.effective_year LIKE ? OR 
				user_profile_reposition.userid LIKE ? OR 
				user_profile_reposition.new_portfolio LIKE ? OR 
				user_profile_reposition.old_portfolio LIKE ? OR 
				employee_details.id LIKE ? OR 
				employee_details.portfolio_id LIKE ? OR 
				employee_details.basic_pay LIKE ? OR 
				employee_details.bank_acc_no LIKE ? OR 
				employee_details.bank_name LIKE ? OR 
				employee_details.email LIKE ? OR 
				employee_details.dob LIKE ? OR 
				employee_details.date_of_join LIKE ? OR 
				employee_details.date_of_retirement LIKE ? OR 
				employee_details.department LIKE ? OR 
				employee_details.IFSC LIKE ? OR 
				employee_details.designation LIKE ? OR 
				employee_details.caste LIKE ? OR 
				employee_details.relegion LIKE ? OR 
				employee_details.nominee LIKE ? OR 
				employee_details.payscale LIKE ? OR 
				employee_details.gender LIKE ? OR 
				employee_details.identification_mark LIKE ? OR 
				employee_details.place_of_birth LIKE ? OR 
				employee_details.balanceleave LIKE ? OR 
				employee_details.mobile LIKE ? OR 
				employee_details.photo LIKE ? OR 
				portfolio.id LIKE ? OR 
				portfolio.name LIKE ? OR 
				user_profile_reposition.timestamp LIKE ? OR 
				portfolio.pid LIKE ?
			)";
			$search_params = array(
				"%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%"
			);
			//setting search conditions
			$db->where($search_condition, $search_params);
			 //template to use when ajax search
			$this->view->search_template = "user_profile_reposition/search.php";
		}
		$db->join("employee_details", "user_profile_reposition.empid = employee_details.id", "INNER");
		$db->join("portfolio", "user_profile_reposition.new_portfolio = portfolio.id", "INNER");
		if(!empty($request->orderby)){
			$orderby = $request->orderby;
			$ordertype = (!empty($request->ordertype) ? $request->ordertype : ORDER_TYPE);
			$db->orderBy($orderby, $ordertype);
		}
		else{
			$db->orderBy("user_profile_reposition.id", ORDER_TYPE);
		}
		if($fieldname){
			$db->where($fieldname , $fieldvalue); //filter by a single field name
		}
		$tc = $db->withTotalCount();
		$records = $db->get($tablename, $pagination, $fields);
		$records_count = count($records);
		$total_records = intval($tc->totalCount);
		$page_limit = $pagination[1];
		$total_pages = ceil($total_records / $page_limit);
		$data = new stdClass;
		$data->records = $records;
		$data->record_count = $records_count;
		$data->total_records = $total_records;
		$data->total_page = $total_pages;
		if($db->getLastError()){
			$this->set_page_error();
		}
		$page_title = $this->view->page_title = "User Profile Reposition";
		$this->view->report_filename = date('Y-m-d') . '-' . $page_title;
		$this->view->report_title = $page_title;
		$this->view->report_layout = "report_layout.php";
		$this->view->report_paper_size = "A4";
		$this->view->report_orientation = "portrait";
		$this->render_view("user_profile_reposition/list.php", $data); //render the full page
	}
	/**
     * View record detail 
	 * @param $rec_id (select record by table primary key) 
     * @param $value value (select record by value of field name(rec_id))
     * @return BaseView
     */
	function view($rec_id = null, $value = null){
		$request = $this->request;
		$db = $this->GetModel();
		$rec_id = $this->rec_id = urldecode($rec_id);
		$tablename = $this->tablename;
		$fields = array("user_profile_reposition.id", 
			"user_profile_reposition.empid", 
			"user_profile_reposition.status", 
			"user_profile_reposition.effective_month", 
			"user_profile_reposition.effective_year", 
			"user_profile_reposition.userid", 
			"user_profile_reposition.timestamp", 
			"user_profile_reposition.new_portfolio", 
			"user_profile_reposition.old_portfolio", 
			"employee_details.id AS employee_details_id", 
			"employee_details.employee_name AS employee_details_employee_name", 
			"employee_details.portfolio_id AS employee_details_portfolio_id", 
			"employee_details.basic_pay AS employee_details_basic_pay", 
			"employee_details.bank_acc_no AS employee_details_bank_acc_no", 
			"employee_details.bank_name AS employee_details_bank_name", 
			"employee_details.email AS employee_details_email", 
			"employee_details.dob AS employee_details_dob", 
			"employee_details.date_of_join AS employee_details_date_of_join", 
			"employee_details.date_of_retirement AS employee_details_date_of_retirement", 
			"employee_details.department AS employee_details_department", 
			"employee_details.IFSC AS employee_details_IFSC", 
			"employee_details.designation AS employee_details_designation", 
			"employee_details.caste AS employee_details_caste", 
			"employee_details.relegion AS employee_details_relegion", 
			"employee_details.nominee AS employee_details_nominee", 
			"employee_details.payscale AS employee_details_payscale", 
			"employee_details.gender AS employee_details_gender", 
			"employee_details.identification_mark AS employee_details_identification_mark", 
			"employee_details.place_of_birth AS employee_details_place_of_birth", 
			"employee_details.balanceleave AS employee_details_balanceleave", 
			"employee_details.mobile AS employee_details_mobile", 
			"employee_details.photo AS employee_details_photo", 
			"portfolio.id AS portfolio_id", 
			"portfolio.name AS portfolio_name", 
			"portfolio.pid AS portfolio_pid");
		if($value){
			$db->where($rec_id, urldecode($value)); //select record based on field name
		}
		else{
			$db->where("user_profile_reposition.id", $rec_id);; //select record based on primary key
		}
		$db->join("employee_details", "user_profile_reposition.empid = employee_details.id", "INNER ");
		$db->join("portfolio", "user_profile_reposition.new_portfolio = portfolio.id", "INNER ");  
		$record = $db->getOne($tablename, $fields );
		if($record){
			$page_title = $this->view->page_title = "View  User Profile Reposition";
		$this->view->report_filename = date('Y-m-d') . '-' . $page_title;
		$this->view->report_title = $page_title;
		$this->view->report_layout = "report_layout.php";
		$this->view->report_paper_size = "A4";
		$this->view->report_orientation = "portrait";
		}
		else{
			if($db->getLastError()){
				$this->set_page_error();
			}
			else{
				$this->set_page_error("No record found");
			}
		}
		return $this->render_view("user_profile_reposition/view.php", $record);
	}
	/**
     * Insert new record to the database table
	 * @param $formdata array() from $_POST
     * @return BaseView
     */
	function add($formdata = null){
		if($formdata){
			$db = $this->GetModel();
			$tablename = $this->tablename;
			$request = $this->request;
			//fillable fields
			$fields = $this->fields = array("empid","status","effective_month","effective_year","old_portfolio","new_portfolio","userid");
			$postdata = $this->format_request_data($formdata);
			$this->rules_array = array(
				'empid' => 'required',
				'effective_month' => 'required',
				'effective_year' => 'required|numeric|max_numeric,3000|min_numeric,1900',
				'old_portfolio' => 'required',
				'new_portfolio' => 'required',
			);
			$this->sanitize_array = array(
				'empid' => 'sanitize_string',
				'effective_month' => 'sanitize_string',
				'effective_year' => 'sanitize_string',
				'old_portfolio' => 'sanitize_string',
				'new_portfolio' => 'sanitize_string',
			);
			$this->filter_vals = true; //set whether to remove empty fields
			$modeldata = $this->modeldata = $this->validate_form($postdata);
			$modeldata['status'] = "AUTHORIZATION PENDING";
$modeldata['userid'] = USER_ID;
			if($this->validated()){
				$rec_id = $this->rec_id = $db->insert($tablename, $modeldata);
				if($rec_id){
		# Statement to execute after adding record
$db->where("rep_id", $rec_id);
$bool = $db->delete("accept_reject_profile_reposition");
$seq = $db->getValue("autorization", "IFNULL(MAX(sequence),0)");
if($seq==0){
    //MAKE READY
    $table_data = array(
    "status" => "READY MIGRATION" 
    );
    $db->where("id", $rec_id);
    $bool = $db->update("user_profile_reposition", $table_data);
}else{
    $db->where("sequence", 1);
    $app_user_id = $db->getValue("autorization", "user");
    $table_data = array(
    "rep_id" => $rec_id,
    "app_userid" => "$app_user_id",
    "stage" => "1"
    );
    $db->insert("accept_reject_profile_reposition", $table_data);
    $db->where("id", $app_user_id);
    $userfullname = $db->getValue("user_info", "user_full_name");
      $db->where("id", $app_user_id);
    $username = $db->getValue("user_info", "username");
    $table_data = array(
    "status" => "SENT TO $userfullname($username) FOR APPROVAL" 
    );
    $db->where("id", $rec_id);
    $bool = $db->update("user_profile_reposition", $table_data);
}
		# End of after add statement
					$this->set_flash_msg("Record added successfully", "success");
					return	$this->redirect("user_profile_reposition");
				}
				else{
					$this->set_page_error();
				}
			}
		}
		$page_title = $this->view->page_title = "Add New User Profile Reposition";
		$this->render_view("user_profile_reposition/add.php");
	}
	/**
     * Update table record with formdata
	 * @param $rec_id (select record by table primary key)
	 * @param $formdata array() from $_POST
     * @return array
     */
	function edit($rec_id = null, $formdata = null){
		$request = $this->request;
		$db = $this->GetModel();
		$this->rec_id = $rec_id;
		$tablename = $this->tablename;
		 //editable fields
		$fields = $this->fields = array("id","empid","status","effective_month","effective_year","old_portfolio","new_portfolio","userid");
		if($formdata){
			$postdata = $this->format_request_data($formdata);
			$this->rules_array = array(
				'empid' => 'required',
				'effective_month' => 'required',
				'effective_year' => 'required|numeric|max_numeric,3000|min_numeric,1900',
				'old_portfolio' => 'required',
				'new_portfolio' => 'required',
			);
			$this->sanitize_array = array(
				'empid' => 'sanitize_string',
				'effective_month' => 'sanitize_string',
				'effective_year' => 'sanitize_string',
				'old_portfolio' => 'sanitize_string',
				'new_portfolio' => 'sanitize_string',
			);
			$modeldata = $this->modeldata = $this->validate_form($postdata);
			$modeldata['status'] = "AUTHORIZATION PENDING";
$modeldata['userid'] = USER_ID;
			if($this->validated()){
				$db->where("user_profile_reposition.id", $rec_id);;
				$bool = $db->update($tablename, $modeldata);
				$numRows = $db->getRowCount(); //number of affected rows. 0 = no record field updated
				if($bool && $numRows){
					$this->set_flash_msg("Record updated successfully", "success");
					return $this->redirect("user_profile_reposition");
				}
				else{
					if($db->getLastError()){
						$this->set_page_error();
					}
					elseif(!$numRows){
						//not an error, but no record was updated
						$page_error = "No record updated";
						$this->set_page_error($page_error);
						$this->set_flash_msg($page_error, "warning");
						return	$this->redirect("user_profile_reposition");
					}
				}
			}
		}
		$db->where("user_profile_reposition.id", $rec_id);;
		$data = $db->getOne($tablename, $fields);
		$page_title = $this->view->page_title = "Edit  User Profile Reposition";
		if(!$data){
			$this->set_page_error();
		}
		return $this->render_view("user_profile_reposition/edit.php", $data);
	}
	/**
     * Delete record from the database
	 * Support multi delete by separating record id by comma.
     * @return BaseView
     */
	function delete($rec_id = null){
		Csrf::cross_check();
		$request = $this->request;
		$db = $this->GetModel();
		$tablename = $this->tablename;
		$this->rec_id = $rec_id;
		//form multiple delete, split record id separated by comma into array
		$arr_rec_id = array_map('trim', explode(",", $rec_id));
		$db->where("user_profile_reposition.id", $arr_rec_id, "in");
		$bool = $db->delete($tablename);
		if($bool){
			$this->set_flash_msg("Record deleted successfully", "success");
		}
		elseif($db->getLastError()){
			$page_error = $db->getLastError();
			$this->set_flash_msg($page_error, "danger");
		}
		return	$this->redirect("user_profile_reposition");
	}
}
